<template>
  <div>
    <div v-if="payForm" id="form" class="container">
      <form class="deduction">
        <div class="columns">
          <div class="column col-6">
            <div class="form-group">
              <label for="period">
                Period
              </label>
              <select class="new_form_input" id="period" v-model="period" v-on:change="setDate">
                <option>Choose Period</option>
                <option>Monthly (Period)</option>
                <option>Monthly (Calendar)</option>
                <option>Daily</option>
                <option>Weekly</option>
                <option>Custom</option>
              </select>
            </div>
          </div>
        </div><br>

        <div class="columns" v-if="remainingHalf">
          <div class="column col-6">
            <div class="form-group">
              <label for="startDate">Start Date</label>
              <!-- <el-date-picker
                v-model="startDate"
                type="date"
                placeholder="Pick a day"
                v-if="dateInput"
                @change="setDate"
              ></el-date-picker> -->
              <input
                class="new_form_input"
                type="date"
                id="startDate"
                placeholder="Name"
                v-model="startDate"
                v-if="dateInput"
                @change="setDate"
              />
              <p v-if="dateDisplay">
                {{ startDate }}
              </p>
            </div>
          </div>

          <div class="column col-6">
            <div class="form-group">
              <label for="endDate">End Date</label>
              <!-- <el-date-picker v-model="endDate" type="date" placeholder="Pick a day" v-if="dateInput"></el-date-picker> -->
              <input 
                v-if="dateInput"
                class="new_form_input"
                type="date"
                id="endDate"
                placeholder="Name"
                v-model="endDate"
              />
              <p v-if="dateDisplay">
                {{ endDate }}
              </p>
            </div>
          </div>
        </div><br>

        <div class="columns" v-if="remainingHalf">
          <div class="column col-6">
            <div class="form-group">
              <label for="payType">
                Pay Type &nbsp;&nbsp;
                <small class="red">*optional</small>
              </label>
              <select class="new_form_input" id="employeeType" v-model="payType">
                <option>Choose an option</option>
                <option>Regular</option>
                <option>Regular Hourly</option>
                <!-- <option v-for="type in types" :key="type.id">{{ type }}</option> -->
              </select>
              <!-- <el-select v-model="payType" multiple collapse-tags placeholder="Select" class="new_form_input">
                <el-option
                  v-for="item in payTypeOptions"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                ></el-option>
              </el-select>-->
            </div>
          </div>
          <div class="column col-6">
            <div class="form-group">
              <label for="employeeType">
                Employee Type &nbsp;&nbsp;
                <small class="red">*optional</small>
              </label>
              <select class="new_form_input" id="employeeType" v-model="employeeType">
                <option>Choose an option</option>
                <option>Full-Time</option>
                <option>Part-Time</option>
                <option>Contract</option>
                <option>Intern</option>
              </select>
            </div>
          </div>
        </div><br>

        <br />

        <div class="columns">
          <div class="column col-6">
            <div class="newBtn">
              <a class="btn btn-link red" href="#modals">
                <img src="images/icons/show_page_cancel.svg" alt="Cancel icon" class />
                <span class="icon_label">CANCEL</span>
              </a>
            </div>
          </div>
          <div class="column col-6 text-right">
            <div class="newBtn" @click="runPayrun">
              <img src="images/icons/Group 335.svg" alt="Run icon" class />
              <span class="icon_label">RUN</span>
            </div>
          </div>
        </div>
      </form>
    </div>

    <div v-if="payDisplay" class="payrunDisplay">
      <div class="columns show_div">
        <div class="column col6 show_label">Pay Run Id</div>
        <div class="column col6 show_field">
          <strong>{{ payrunId }}</strong>
        </div>
      </div>
      <div class="columns show_div grey_div">
        <div class="column col6 show_label">Start Date</div>
        <div class="column col6 show_field">
          <strong>{{ startDate }}</strong>
        </div>
      </div>
      <div class="columns show_div">
        <div class="column col6 show_label">End Date</div>
        <div class="column col6 show_field">
          <strong>{{ endDate }}</strong>
        </div>
      </div>
      <div class="columns show_div grey_div">
        <div class="column col6 show_label">Period</div>
        <div class="column col6 show_field">
          <strong>{{ period }}</strong>
        </div>
      </div>
      <div class="columns show_div">
        <div class="column col6 show_label">Employee Type</div>
        <div class="column col6 show_field">
          <strong>{{ employeeType }}</strong>
        </div>
      </div>
      <div class="columns show_div grey_div">
        <div class="column col6 show_label">Pay Type</div>
        <div class="column col6 show_field">
          <strong>{{ payType }}</strong>
        </div>
      </div>
      <br />
      <div class="columns">
        <div class="column col-6">
          <div class="newBtn">
            <a class="btn btn-link red" href="#modals" @click="reset">
              <img src="images/icons/show_page_cancel.svg" alt="Cancel icon" class />
              <span class="icon_label">CANCEL</span>
            </a>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import store from "../js/store/store";
// import { mapState } from 'vuex'

export default {
  name: "PayrollForm",
  props: ["modalActive"],
  data() {
    return {
      payrunId: "",
      startDate: "",
      endDate: "",
      employeeType: "",
      payTypeOptions: [
        {
          value: "Salary",
          label: "Salary"
        },
        {
          value: "Leave",
          label: "Leave"
        }
      ],
      payType: [],
      period: "",
      payForm: true,
      payDisplay: false,
      csrf: window.csrf_token,
      dateDisplay: false,
      dateInput: true,
      types: ["Basic", "Housing", "Transport", "Meal", "Utilities", "Leave", "Dressing", "Entertainment", "Telephone", "Car", "Benefit" ],
      payruns: [],
      remainingHalf: false
    };
  },
  methods: {
    payrun: function() {
      var today = new Date();

      this.payrunId = today.setDate(today.getDate());

      this.payForm = false;
      this.payDisplay = true;
    },
    appendLeadingZeroes(n){
      if(n <= 9){
        return "0" + n;
      }
      return n
    },
    calendarDate: function() {
      var startDate = this.startDate
      this.endDate = new Date(startDate.setDate(startDate.getDate() + 30))
    },
    setDate: function() {
      this.remainingHalf = true;
      if (this.period == "Monthly (Period)") {
        let endDate = new Date()
        this.endDate = endDate.getFullYear() + "-" + (this.appendLeadingZeroes(endDate.getMonth() + 1)) + "-" + endDate.getDate()

        var startDate = new Date(endDate.setDate(endDate.getDate() - 30));
        
        this.startDate = startDate.getFullYear() + "-" + (this.appendLeadingZeroes(startDate.getMonth() + 1)) + "-" + startDate.getDate()

        this.dateDisplay = false;
        this.dateInput = true;
      } else if (this.period == "Monthly (Calendar)") {
        var date = new Date();
        this.startDate =
          date.getFullYear() + "-" + (this.appendLeadingZeroes(date.getMonth() + 1)) + "-" + "01";

        var startDate = new Date(this.startDate);
        var endDate = new Date(startDate.setDate(startDate.getDate() + 30));
        this.endDate =
          endDate.getFullYear() +
          "-" +
          (this.appendLeadingZeroes(endDate.getMonth() + 1)) +
          "-" +
          endDate.getDate();

        this.dateDisplay = false;
        this.dateInput = true;
        
      } else {
        this.dateInput = true
        this.dateDisplay = false
      }
    },
    cancelPayDisplay() {
      this.payrunId = "";
      this.startDate = "";
      this.endDate = "";
      this.employeeType = "";
      this.payType = "";
      this.period = "";
      this.payDisplay = false;
      this.payForm = true;
    },
    reset() {
      this.cancelPayDisplay();
    },    
    runPayrun() {
      var params = {
        payrun: {
          start_date: this.startDate,
          end_date: this.endDate,
          pay_type: this.payType,
          employee_type: this.employeeType
        }
      }

      var url = "api/payrun";
      let csrf = document
        .querySelector("meta[name='csrf-token']")
        .getAttribute("content")

      axios
        .post(url, params, {
          headers: { "Content-Type": "application/json", "x-csrf-token": csrf }
        })
        .then((response)=>{
          this.payrunId = response.data.id

          this.createLedger()

          

        })

      // window.location.reload()
      // window.location.href="/payroll";

    },
    createLedger() {
      var params = {
        ledger_params: {
          payrun_id: this.payrunId,
          start_date: this.startDate,
          end_date: this.endDate
        }
      };

      var url = "api/ledger"
      let csrf = document
        .querySelector("meta[name='csrf-token']")
        .getAttribute("content")

      axios
        .post(url, params, {
          headers: { "Content-Type": "application/json", "x-csrf-token": csrf }
        })
        .then(response => {
          this.$store.commit("change_employees_ledger", response.data.payroll);
          this.$store.commit(
            "change_employees_ledger_total",
            response.data.total
          );
          console.log("Store", this.$store);

          window.location.href="/payroll";
        })
    },
    runPayroll() {
      // this.payrun();
      var params = {
        ledger_params: {
          payrun_id: this.payrunId,
          start_date: this.startDate,
          end_date: this.endDate
        }
      };

      var url = "api/ledger";
      let csrf = document
        .querySelector("meta[name='csrf-token']")
        .getAttribute("content");

      axios
        .post(url, params, {
          headers: { "Content-Type": "application/json", "x-csrf-token": csrf }
        })
        .then(response => {
          this.$store.commit("change_employees_ledger", response.data.payroll);
          this.$store.commit(
            "change_employees_ledger_total",
            response.data.total
          );
          console.log("Store", this.$store);
        })
        .catch(function(error) {
          console.log(error);
        });
    }
  }
};
</script>
<style scoped>
.deduction {
  margin-left: 0.45rem;
  margin-right: 0.65rem;
}

.el-input__inner {
  border-color: #c4cdd5 !important;
  /* height: 1.8rem; */
}
.red {
  color: red;
}
.payrunDisplay {
  margin-left: 1.15rem;
  margin-right: 1.65rem;
}
</style>
